Index: /extensions/LLGBO2/main.inc.php
===================================================================
--- /extensions/LLGBO2/main.inc.php	(revision 28989)
+++ /extensions/LLGBO2/main.inc.php	(revision 28990)
@@ -2,5 +2,5 @@
 /*
 Plugin Name: Look_like_gbo2 
-Version:  2.5.B
+Version: 2.7.A
 Plugin URI: http://phpwebgallery.net/ext/extension_view.php?eid=251
 Author: GBo 
@@ -18,204 +18,241 @@
 	2.5.A Fix bug  back to default values after  deactivates / reactivates actions 
 	2.5.B Fix bug  back to default values after  deactivates / reactivates actions (with API)
+	2.5.C Fix bug  notice with $lang
+-- 30-12-2013   
+		2.6.A Compliance Piwigo 2.6	and automatic size
+-- 01-07-2014   
+		2.7.A Compliance Piwigo 2.7	new administration management
  */
 if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
 
-global $conf; 
-define ('LLGBO_INFO_VERSION','2.5.B');
-if (!defined('LLGBO_PATH'))
-{define('LLGBO_PATH', PHPWG_PLUGINS_PATH.basename(dirname(__FILE__)). '/');}
-	 
- $conf['LLGBO_SETTINGS'] =  explode("," , $conf['LLGBO']);
- $conf['LLGBO_TOOLTIP'] = explode(",",$conf['LLGBOTOOLTIP']);
- $conf['LLGBO_FRAME'] = explode (",",$conf['LLGBOFRAME']); 
- $conf['LLGBO_HEADER'] = explode (",",$conf['LLGBOHEADER']); 
+
+// +-----------------------------------------------------------------------+
+// | Plugin constants                                               |
+// +-----------------------------------------------------------------------+
+define('LLGBO_VERSION', '2.7.A');
+define('LLGBO_ID',       basename(dirname(__FILE__)));
+define('LLGBO_PATH' ,    PHPWG_PLUGINS_PATH . LLGBO_ID . '/');
+define('LLGBO_ADMIN',    get_root_url() . 'admin.php?page=plugin-' . LLGBO_ID);
+// +-----------------------------------------------------------------------+
+/*				 Set the administration panel of the plugin */
+// +-----------------------------------------------------------------------+
+function llgbo_admin_menu($menu)
+  {  
+	$menu[] = array(
+		'NAME' => 'Look like Gbo',
+		'URL' => LLGBO_ADMIN,
+    );
+  return $menu;
+	}
+// +-----------------------------------------------------------------------+
+// | Plugin initialization                                                 |
+// +-----------------------------------------------------------------------+
+function llgbo_init()
+{
+	global $conf,$CF_LLGBO;
+	Load_language('plugin.lang', LLGBO_PATH);
+
+	$CF_LLGBO2settings =  unserialize($conf['LLGBO2settings']);
+	$CF_LLGBO2tooltip = unserialize($conf['LLGBO2tooltip']);
+	$CF_LLGBO2frame = unserialize($conf['LLGBO2frame']);
+	$CF_LLGBO2header = unserialize($conf['LLGBO2header']);
+	$CF_LLGBO =array_merge((array)$CF_LLGBO2settings, (array)$CF_LLGBO2tooltip,(array) $CF_LLGBO2frame,(array) $CF_LLGBO2header);
+}
+
+
+/******************************************************************/
+/*       ALWAYS      DISPLAY      METADATA */
+/******************************************************************/
+function llgbo_BeginPicture()
+/******************************************************************/
+{global $CF_LLGBO,$template;
+	If ($CF_LLGBO['exifunderbt'])  // exif under bt
+		{$_GET['metadata'] = 'O';}
+		
+	If ($CF_LLGBO['alwaysdisplayexif'])  //always display metadata
+		{if ( pwg_get_session_var('show_metadata') == null )
+			{  pwg_set_session_var('show_metadata', 1 );	 }
+		}
+}// --------------- end begin picture 
+
+/******************************************************************/
+//      MANAGE     BEGIN          H E A D E R 
+/******************************************************************/
+function llgbo_beginheader()
+/******************************************************************/
+{ global $page,$CF_LLGBO;
+	If ($CF_LLGBO['exifunderbt'] ) // reset nofollow, noindex
+	{ unset ($page['meta_robots']);}
+}
+/******************************************************************/
+//      MANAGE               H E A D E R 
+/******************************************************************/
+function llgbo_endHeader()
+/******************************************************************/
+{global $template,$conf,$CF_LLGBO;
+	$page_name = script_basename();
+	include_once(LLGBO_PATH.'include/manage_header.php');
+}  // --------------- end header 
+
+
+/******************************************************************/
+//* IMPROVE FUNCTIONNALITIES --> PICTURE.TPL
+/******************************************************************/
+function  llgbo_EndPicture()
+/******************************************************************/
+{ global $template,$CF_LLGBO,$conf,$page,$lang;
+	//----------------------------------------------------	 
+	/*       HTML End  frame   on Picture.tpl       */
+	//----------------------------------------------------	
+			
+	If (($CF_LLGBO['frame'])    //Frame
+		 and ($CF_LLGBO['rendercontent'])	)// $content ok for update
+		{ 	$target = 'picture';
+			if ($page['slideshow'] and $conf['light_slideshow'])
+			{ $target = 'slideshow';}
+			$template->set_prefilter($target, 'LLGBO_prefilter_Picture_Frame');
+		 //$PictSizeWH is not already defined by auto_size 	
+		  $current= $template->get_template_vars('current'); 
+		  if (empty($CF_LLGBO['PictSizeWH']))
+				{$CF_LLGBO['PictSizeWH'] =  $current['selected_derivative']->get_size();}
+			$PictSizeWH = $CF_LLGBO['PictSizeWH'];		
+			$frame_width  = $PictSizeWH[0];
+			$frame_height = $PictSizeWH[1];
+			$frame_begin ='';
+			 foreach ($CF_LLGBO['FR-sizes'] as $cle  => $value) 
+				{ if ( $value > 0)	// boder value > 0	
+					 {	$frame_width = $frame_width + ( 2 * $value);				 
+						$frame_height = $frame_height + ( 2* $value); 
+						$frame_begin = '<div class="llgboFR" style="border:'.$value.'px solid '.$CF_LLGBO['FR-colors'][$cle].'">'."\n".$frame_begin;
+						} 
+				}
+				
+			$frame_size = "\n".'<!-- Begin LLGBO frame -->'."\n".'<div   id="llgbo0" class="llgbo" style="border:0 ;width:'.$frame_width.'px; height:'.$frame_height.'px;">';
+			$template->append('llgbo', array(
+				 'FRAME_SIZE' => $frame_size ,
+				 'FRAME_BEGIN' => $frame_begin), true); 
+				 
+		If ($CF_LLGBO['titleframe'] )  
+			 {  $template->append('llgbo', array(
+					 'TITLE_FRAME_COLOR' => $CF_LLGBO['FR-titlecolor'],
+					 'TITLE_FRAME' => $current['name'] ), true);
+				$template->assign('SHOW_PICTURE_NAME_ON_TITLE' , false); 
+				}			
+		} //--------------- end frame
+		
 	
- load_language('plugin.lang', LLGBO_PATH);
-
-/* Set the administration panel of the plugin */
-  function plugin_admin_menu($menu)
-  {    array_push($menu,
-        array(
-          'NAME' => 'Look_like_GBo',
-          'URL' => get_admin_plugin_menu_link(dirname(__FILE__).'/admin/llgbo_admin.php') ));
-    return $menu;  }
-
-//-------------------------------------------------------------
-/*       ALWAYS      DISPLAY      METADATA */
-//-------------------------------------------------------------
-function llgbo_BeginPicture()
-{global $conf,$template;
-If ($conf['LLGBO_SETTINGS'] [2]  == 'true' )  // exif under bt
-	{$_GET['metadata'] = 'O';}
-	
-If ($conf['LLGBO_SETTINGS'][10]  == 'true' )  //always display metadata
-	{if ( pwg_get_session_var('show_metadata') == null )
-		{  pwg_set_session_var('show_metadata', 1 );
-		 }}
-
-}
-
-function llgbo_beginheader()
-{ global $page,$conf;
-	If ($conf['LLGBO_SETTINGS'][2]  == 'true' ) // reset nofollow, noindex
-	{ unset ($page['meta_robots']);}
-}
-//-------------------------------------------------------------
-//      MANAGE               H E A D E R 
-//-------------------------------------------------------------
-function llgbo_endHeader()
-{global $template,$conf;
-$page_name = script_basename();
-include_once(LLGBO_PATH.'include/manage_header.php');
-}  // end header 
-//------------------------------------------------------------- 
-//* IMPROVE FUNCTIONNALITIES --> PICTURE.TPL
-//-------------------------------------------------------------	
-function  llgbo_EndPicture()
-{ global $template,$conf,$page;
-$infofile = $template->get_template_vars('INFO_FILE');
-$current = $template->get_template_vars('current');
-//----------------------------------------------------	 
-/*       HTML End  frame   on Picture.tpl       */
-//----------------------------------------------------	
-If (($conf['LLGBO_SETTINGS'] [0] == 'true')    //Frame
-     and ($conf['LLGBO_RENDERCONTENT'] == 'true') )	// $content ok for update
-	{ 	$target = 'picture';
-	    if ($page['slideshow'] and $conf['light_slideshow'])
-		{ $target = 'slideshow';}
-		$template->set_prefilter($target, 'LLGBO_prefilter_Picture_Frame');
-		
-		If (isset($conf['LLGBO_SETTINGS'] ['rirs']))
-		{ // Force javascript LlgboFr_Resize  to Read MainImage Reel Size via URL 
-		  // Must be used when html image is already resize by HTML (IE or Chrome)
-		If ($conf['LLGBO_SETTINGS'] ['rirs']  == 'true') // Forcce javascript to read Image reel size
-			{$template->append('llgbo', array('READIMGREELSIZE'  => "ok"), true); }
+	// ---- Metadata ----------	
+	$ext = get_extension($current['path']);
+	if (!in_array($ext, $conf['picture_ext'])) 
+		{$lang['Show file metadata'] =  'No Metadata';}
+		else
+		{if ($conf['show_exif']) // No exif ?
+			{$meta = "";
+			$u_metadata = $template->get_template_vars('U_METADATA');
+			$swt = "";
+			 If ($CF_LLGBO['exifunderbt'])  // exif under bt
+				{  $metadata = $template->get_template_vars('metadata');
+				if (is_array($metadata)) 
+				  {  if (isset($metadata[0]) and is_array($metadata[0]))
+						{foreach($metadata[0] as $cle =>$tableau)
+							{ if(is_array($tableau))
+							 {   foreach($tableau as $cle=>$valeur)
+								{   $swt= $swt.$cle.' : '.$valeur.'||';
+									$meta = 1;} }	}
+							if  ( pwg_get_session_var('show_metadata') == 1 )
+							{  	$lang['Show file metadata'] =  'EXIF Metadata';
+								 if (isset($metadata[0] ['TITLE'])) // advanced meta
+								{$lang['Show file metadata']	= $metadata [0] ['TITLE'];}
+								if ($meta  != 1 ) {$lang['Show file metadata'] =  'No Metadata';}
+							}
+							$template->assign( 'U_METADATA', $u_metadata.'" title="'.$lang['Show file metadata']."||".$swt);
+							unset( $metadata[0]); 
+							 $template->Clear_assign('metadata');// hide original metadata	
+							 $template->assign('metadata',$metadata);} //  original metadata item > 0	
+				  }
+				  else
+				  {if  ( pwg_get_session_var('show_metadata') == 1 )
+				  {$lang['Show file metadata'] =  'No Metadata';
+				   $template->assign( 'U_METADATA', $u_metadata.'" title="'.$lang['Show file metadata']);}
+				   }
+				} 
 			}
-// selected picture Size			
-	$PictSizeWH  =  $current['selected_derivative']->get_size();	
-	$frame_width  = $PictSizeWH[0];
-		$frame_height = $PictSizeWH[1];
-		$lastbrdpx = 0;
-		$frame_begin ='';
-		for ($x = 1   ;$x < 32  ; $x =$x +2)
-		{ 	if ((isset($conf['LLGBO_FRAME'][$x+1])) and  ($conf['LLGBO_FRAME'][$x+1] > 0))	// boder value > 0	
-			  { $bordpx= $conf['LLGBO_FRAME'][$x+1]; 
-				$frame_width = $frame_width + ( 2* $lastbrdpx);				 
-				$frame_height = $frame_height + ( 2* $lastbrdpx); 
-			    $bordcolor = $conf['LLGBO_FRAME'][$x];
-			    $frame_begin = '<div   id="llgboframe'.$x.'" class="llgbo" style="border:'.$bordpx.'px solid '.$bordcolor.'">'."\n".$frame_begin;
-				$lastbrdpx = $bordpx;}
 		}
-		$frame_width = $frame_width + ( 2* $lastbrdpx);				 
-		$frame_height = $frame_height + ( 2* $lastbrdpx); 
-		$frame_size = 'style="border:0 ;width:'.$frame_width.'px; height:'.$frame_height.'px;"';
-		$template->append('llgbo', array(
-			 'FRAME_SIZE' => $frame_size,
-			 'FRAME_BEGIN' => $frame_begin), true); 
-	If (($conf['LLGBO_SETTINGS'] [5]  == 'true' )  /* title on frame */ 
-	and ($conf['LLGBO_SETTINGS'] [0]  == 'true' ) )// frame
-		 {  $template->append('llgbo', array(
-				 'TITLE_FRAME_COLOR' => $conf['LLGBO_FRAME'][0],
-				 'TITLE_FRAME' => $current['name'] ), true);
-			$template->assign('SHOW_PICTURE_NAME_ON_TITLE' , false); 
-			}
-	} //end frame
-// ---- Metadata ----------	
-$pictExt = substr($infofile,-3);
-if (!in_array ( $pictExt,$conf['picture_ext']))
-	{$lang['Show file metadata'] =  'No Metadata';}
-	else
-	{
-	if ($conf['show_exif'] 	== true) // No exif ?
-	{$meta = "";
-	$u_metadata = $template->get_template_vars('U_METADATA');
- 	$swt = "";
-	 If ($conf['LLGBO_SETTINGS'] [2]  == 'true' )  // exif under bt
-		{  $metadata = $template->get_template_vars('metadata');
-		if (is_array($metadata)) 
-		  {  if (isset($metadata[0]) and is_array($metadata[0]))
-				{foreach($metadata[0] as $cle =>$tableau)
-					{ if(is_array($tableau))
-					 {   foreach($tableau as $cle=>$valeur)
-						{   $swt= $swt.$cle.' : '.$valeur.'||';
-							$meta = 1;} }	}
-					if  ( pwg_get_session_var('show_metadata') == 1 )
-					{  	$lang['Show file metadata'] =  'EXIF Metadata';
-						 if (isset($metadata[0] ['TITLE'])) // advanced meta
-						{$lang['Show file metadata']	= $metadata [0] ['TITLE'];}
-						if ($meta  != 1 ) {$lang['Show file metadata'] =  'No Metadata';}
-					}
-					$template->assign( 'U_METADATA', $u_metadata.'" title="'.$lang['Show file metadata']."||".$swt);
-					unset( $metadata[0]); 
-					 $template->Clear_assign('metadata');// hide original metadata	
-					 $template->assign('metadata',$metadata);} //  original metadata item > 0	
-		  }
-		  else
-		  {if  ( pwg_get_session_var('show_metadata') == 1 )
-		  {$lang['Show file metadata'] =  'No Metadata';
-		   $template->assign( 'U_METADATA', $u_metadata.'" title="'.$lang['Show file metadata']);}
-		   }
-		} 
-	  }
-	}
+	// --------------------------------------
 	// Add llgbo requirement to ELEMENT_CONTENT
+	// --------------------------------------
 	$template->set_filenames( array('llgbo_content'=> dirname(__FILE__).'/template/llgbo_content.tpl') );
-	$template->concat('ELEMENT_CONTENT', $template->parse('llgbo_content', true));
+	$template->concat('picture', $template->parse('llgbo_content', true));
 } 
-//-----------------------------------------------------------------
-/*  ------   MANAGE PICTURE PAGE                --------------    */ 
-//-----------------------------------------------------------------
-function llgbo_RenderContent($content,$element_info )
-{global $template,$conf,$user,$lang,$themeconf;	
-$template->assign('LLGBO_PATH',LLGBO_PATH);
-include_once(LLGBO_PATH.'/css/sweettitles.css.php');
-//-----------------------------------------------------------------
-// -----------  add CSS tooltip in footer --------------------
-//-----------------------------------------------------------------
- If (($conf['LLGBO_SETTINGS'][1]  == 'true' ) /*  tooltip  */  
- or  ($conf['LLGBO_SETTINGS'] [2]  == 'true' )  /* exif under bt */ )    
-	{	$template->append('footer_elements',$sweetcss);
-	$template->append('llgbo', array( 'TOOLTIP' => 'ok' ), true);}
-	
-/*	 If ($conf['LLGBO_SETTINGS'] [3]  == 'true' )    switch free 	{}  */
-$conf['LLGBO_RENDERCONTENT']   = 'false';
-//-----------------------------------------------------------------
-// AN OTHER PLUGIN IS WORKING -> GO BACK
-if ( !empty($content) )   {  return $content;  }	
-// frame and navigation on picture  are only available on picture extension	
-$pictExt = substr($element_info['file'],-3);
-if (!in_array ( $pictExt,$conf['picture_ext']))	{  return $content;  ; }
-$conf['LLGBO_RENDERCONTENT']  = 'true';	// $content ok for update
+
+
+
+/******************************************************************
+			------   MANAGE PICTURE PAGE                --------------     
+ ******************************************************************/
+ // --> function llgbo_RenderContent($content,$element_info)
  include_once(LLGBO_PATH.'include/manage_picture_content.php');
-} //end --> llgbo_RenderContent
-
-function LLGBO_prefilter_Content_Frame($content, &$smarty)
-{   //  End frame  picture_content TPL
+/******************************************************************/		 
+  
+
+
+/******************************************************************/
+function LLGBO_prefilter_Content_Frame($content, $smarty)
+/******************************************************************/
+{  
+// --------------------------------------
+// add  End frame  picture_content TPL
+// --------------------------------------
   global $themeconf;
   $search = '{foreach from=$current.unique_derivatives';
-  $replacement =  "\n".'{$llgbo.FRAME_END}'."\n"."</div> <!-- end GBO frame -->"."\n".$search;
- if (( strpos(strtoupper($themeconf['name']) , 'STRIPPED') === 0) ) 
-	{$search = 'class="hideTabs">';
-  $replacement =  $search."\n".'{$llgbo.FRAME_END}'."\n"."</div> <!-- end GBO frame -->";}
-  return str_replace($search, $replacement, $content);
-}
-
-function LLGBO_prefilter_Picture_Frame($content, &$smarty)
-{
-// ------------------------
-//  begin frame on picture TPL
- $search = '{$ELEMENT_CONTENT}';
- $replacement = '{if isset($llgbo.TITLE_FRAME)}'."\n".'<span  id="llgboh2" style ="background:transparent;z-index:3;color:{$llgbo.TITLE_FRAME_COLOR}">{$llgbo.TITLE_FRAME}</span>';
- $replacement = $replacement."\n".'{/if}'."\n".'<div   id="llgbo0" class="llgbo" {$llgbo.FRAME_SIZE}>'."\n".'{$llgbo.FRAME_BEGIN}'."\n".$search;
+  $replacement = '{$llgbo.FRAME_END}'.'</div>'."\n".' <!-- end LLGBO frame -->'."\n".$search;
+	if (( strpos(strtoupper($themeconf['name']) , 'STRIPPED') === 0) ) 
+		{$search = 'class="hideTabs">';
+		$replacement =  $search
+		.'{$llgbo.FRAME_END}'
+		."</div>";
+		}
+   if (( strpos(strtoupper($themeconf['name']) , 'PWGCARBON_DFT') === 0) ) 
+		{$search = '{if $DISPLAY_NAV_THUMB}';
+		$replacement =   '{$llgbo.FRAME_END}'
+		."</div>"."</div> <!-- end GBO frame -->"
+		.$search;
+		} 
+  $content = str_replace($search, $replacement, $content); 
+  return $content;
+}
+
+
+/******************************************************************/
+function LLGBO_prefilter_Picture_Frame($content, $smarty)
+/******************************************************************/
+{  
+// ------------------------------------
+//  add begin frame on picture TPL
+// --------------------------------------
+ $search = '<div id="theImage">';
+ $replacement = $search."\n".'{if isset($llgbo.TITLE_FRAME)}'."\n".'<span  id="llgboh2" style ="background:transparent;z-index:3;color:{$llgbo.TITLE_FRAME_COLOR}">{$llgbo.TITLE_FRAME}</span>';
+ $replacement = $replacement."\n".'{/if}'."\n".'{$llgbo.FRAME_SIZE}'."\n".'{$llgbo.FRAME_BEGIN}';
+
 // ------------------------
   return  str_replace($search, $replacement, $content);
-}
-
-/* trigger à intercepter                                   */ 
-add_event_handler('loc_begin_page_header', 'llgbo_beginheader');
-add_event_handler('loc_end_page_header', 'llgbo_endHeader');
-Add_event_handler( 'loc_begin_picture','llgbo_BeginPicture');
-Add_event_handler( 'loc_end_picture', 'llgbo_EndPicture');
-add_event_handler('render_element_content', 'llgbo_RenderContent',  EVENT_HANDLER_PRIORITY_NEUTRAL-1, 20  );
-add_event_handler('get_admin_plugin_menu_links',  'plugin_admin_menu' );
+
+}
+/******************************************************************/
+//    trigger à intercepter    
+/******************************************************************/    
+ add_event_handler('init', 'llgbo_init'); 
+if (defined('IN_ADMIN'))
+{
+  add_event_handler('get_admin_plugin_menu_links', 'llgbo_admin_menu');
+}
+else
+{                    
+	add_event_handler('loc_begin_page_header', 'llgbo_beginheader');
+	add_event_handler('loc_end_page_header', 'llgbo_endHeader');
+	Add_event_handler( 'loc_begin_picture','llgbo_BeginPicture');
+	Add_event_handler( 'loc_end_picture', 'llgbo_EndPicture');
+	add_event_handler('render_element_content', 'llgbo_RenderContent',  EVENT_HANDLER_PRIORITY_NEUTRAL-1, 20  );
+}
+
 ?>
Index: /extensions/LLGBO2/maintain.inc.php
===================================================================
--- /extensions/LLGBO2/maintain.inc.php	(revision 28989)
+++ /extensions/LLGBO2/maintain.inc.php	(revision 28990)
@@ -24,62 +24,105 @@
 // | USA.                                                                  |
 // +-----------------------------------------------------------------------+
+/*                                      */
+if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
 
-// ******************************************
-// ** Database install - uninstall queries **
-// ******************************************
-if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
-function plugin_install()
-{  global $prefixeTable,$conf; 
-if (!defined('LLGBO_PATH'))
-{define('LLGBO_PATH', PHPWG_PLUGINS_PATH.basename(dirname(__FILE__)). '/');}
-include(LLGBO_PATH.'defaultvalues.php');
-  plugin_uninstall(); // en cas de mauvaise deinstallation anterieure
-	$q = '
-INSERT INTO '.CONFIG_TABLE.' (param,value,comment)
-	VALUES  
-	("LLGBO","'.$plugvalues.'","look like gbo global settings");';
-  pwg_query($q);
-  	$q = '
-INSERT INTO '.CONFIG_TABLE.' (param,value,comment)
-	VALUES  
-	("LLGBOTOOLTIP","'.$ttvalues.'","look like gbo tooltip settings");';
-  pwg_query($q);
-  	$q = '
-INSERT INTO '.CONFIG_TABLE.' (param,value,comment)
-	VALUES  
-	("LLGBOFRAME","'.$frvalues.'","look like gbo frame settings");';
-  pwg_query($q);
-    	$q = '
-INSERT INTO '.CONFIG_TABLE.' (param,value,comment)
-	VALUES  
-	("LLGBOHEADER","'.$headvalues.'","look like gbo header settings");';
-  pwg_query($q);
-  
-$conf['LLGBO_SETTINGS'] =  explode("," , $plugvalues);
-$conf['LLGBO_TOOLTIP'] = explode(",",$ttvalues);
-$conf['LLGBO_FRAME'] = explode (",", $frvalues); 
-$conf['LLGBO_HEADER'] = explode (",", $headvalues);
- 
+class MyLLGBO_maintain extends PluginMaintain
+{
+// +-----------------------------------------------------------------------+
+// +---------------  Install all settings  --------------------------------+
+// +-----------------------------------------------------------------------+
+    function install($plugin_version, &$errors=array()) { 
+		global $conf; 
+// +-----------------------------------------------------------------------+
+// +----------------- default values            ---------------------------+
+// +-----------------------------------------------------------------------+	
+		include(LLGBO_PATH.'defaultvalues.php');
+// +-----------------------------------------------------------------------+	
+		if (empty($conf['LLGBO2settings']))
+			{ 	if  (isset($conf['LLGBO'])) // compatibility 2.6 --> 2.7
+					{ $Oldvalues = explode("," , $conf['LLGBO']);			
+					foreach($Oldvalues as $cle  => $valeur) 
+					{	if ($Oldvalues[$cle]  == 'true' )
+							{$Oldvalues[$cle]  = (boolean)true ;} 	else { $Oldvalues[$cle]  = (boolean)false;}
+					}
+						$default_Main = array(
+							'version' => 1,
+							'frame' =>   			 $Oldvalues[0] ,
+							'tooltipdisp' => 		 $Oldvalues[1], 
+							'exifunderbt' => 		 $Oldvalues[2], 
+							'titleframe' => 		 $Oldvalues[5], 
+							'manageheader'=>  		 $Oldvalues[6], 
+							'alwaysdisplayexif' => 	 $Oldvalues[10],);
+						conf_delete_param('LLGBO');  // old values before 2.7
+					}
+				conf_update_param('LLGBO2settings',serialize($default_Main), true);
+			}	 
+// +-----------------------------------------------------------------------+				
+		if (empty($conf['LLGBO2tooltip'])) 
+			{ 	if  (isset($conf['LLGBOTOOLTIP'])) // compatibility 2.6 --> 2.7
+					{	 $Oldvalues = explode("," , $conf['LLGBOTOOLTIP']);
+						  $default_tooltip = array(
+							'TT-width' => $Oldvalues[0],
+							'TT-size' => $Oldvalues[1],
+							'TT-bordercolor' => $Oldvalues[2],
+							'TT-bgcolor' => $Oldvalues[3],
+							'TT-titlecolor' => $Oldvalues[4],
+							'TT-textcolor' => $Oldvalues[5]);
+							
+							conf_delete_param('LLGBOTOOLTIP');  // old values before 2.7
+					}
+				conf_update_param('LLGBO2tooltip',serialize($default_tooltip), true);
+			}
+// +-----------------------------------------------------------------------+				
+		if (empty($conf['LLGBO2frame']))   	
+			{ if (isset($conf['LLGBOFRAME']))  // compatibility 2.6 --> 2.7
+				{	 $Oldvalues = explode("," , $conf['LLGBOFRAME']);
+				     $i=0;
+					for ($x = 1   ;$x < 32  ; $x =$x +2)
+					{ 	$newcolors[$i]  = $Oldvalues[$x];  
+						$newsizes[$i]  =  $Oldvalues[$x +1];
+						$i = $i +1;
+					}
+					$default_frame = array(
+						'FR-titlecolor' =>  $Oldvalues[0],
+						'FR-sizes'     => $newsizes,
+						'FR-colors'   => $newcolors	);
+					
+					conf_delete_param('LLGBOFRAME');  // old values before 2.7
+				} 
+				conf_update_param('LLGBO2frame', serialize($default_frame), true);
+			}
+// +-----------------------------------------------------------------------+					
+		if (empty($conf['LLGBO2header']))  	
+			{ if (isset($conf['LLGBOHEADER']))  // compatibility 2.6 --> 2.7
+				{ 	$Oldvalues = explode("," , $conf['LLGBOHEADER']);
+			 		$i = 0;
+					foreach($default_header['HD-dispheader'] as $cle  => $valeur) 
+					{	if ($Oldvalues[$i] == 'true' )  {$Oldvalues[$i] = (boolean)true ;} else { $Oldvalues[$i] = (boolean)false;}
+						$default_header['HD-dispheader'][$cle] = $Oldvalues[$i];
+						$i = $i +1;}
+					conf_delete_param('LLGBOHEADER');  // old values before 2.7
+				} 
+				conf_update_param('LLGBO2header',serialize($default_header), true);	
+			}
+	}
+
+	
+// +-----------------------------------------------------------------------+		
+// +-----------------------------------------------------------------------+			
+	function activate($plugin_version, &$errors=array())
+	  {   $this->install($plugin_version, $errors);  
+  	}
+// +-----------------------------------------------------------------------+
+	function deactivate() { 
+	 /*   */
+	 }
+// +-----------------------------------------------------------------------+
+	function uninstall() {  
+		conf_delete_param('LLGBO2settings');
+		conf_delete_param('LLGBO2tooltip');
+		conf_delete_param('LLGBO2frame');
+		conf_delete_param('LLGBO2header'); 
+	}
 }
-function plugin_activate()
-{ global $prefixeTable,$conf; 
- ///////////////////////////////////////////////////
-// Vérification de la config, si pas bon -> reinstallation
-
-//
- if ( (!isset($conf['LLGBO'])) or (substr_count($conf['LLGBO'], ',')  != 10)  
- or  (!isset($conf['LLGBOTOOLTIP'])) or (substr_count($conf['LLGBOTOOLTIP'], ',')  != 5) 
- or  (!isset($conf['LLGBOFRAME'])) or (substr_count($conf['LLGBOFRAME'], ',')  != 32)
- or  (!isset($conf['LLGBOHEADER'])) or (substr_count($conf['LLGBOHEADER'], ',')  != 21))  
-	{	
-	plugin_install(); }
-}
-
-function plugin_uninstall()
-{ global $prefixeTable;
-   $q = '
-DELETE FROM '.CONFIG_TABLE.' WHERE param like "LLGBO%" LIMIT 5;';
-  pwg_query( $q );
-}
-
 ?>
